<?php

namespace LaraBB\Group\UI\Web\Requests;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Http\RedirectResponse;

/**
 * Class Destroy
 * @package LaraBB\Group\UI\Web\Requests
 */
class Destroy extends FormRequest
{
    /**
     * @return bool
     */
    public function authorize(): bool
    {
        return true;
    }

    /**
     * @return string[]
     */
    public function rules(): array
    {
        return [
            'uuid' => 'required|uuid|exists:groups,uuid'
        ];
    }

    /**
     * @return array|string[]
     */
    public function messages(): array
    {
        return [
            'uuid.required' => 'Es wurde keine UUID übergeben.',
            'uuid.uuid'     => 'Die übergebene UUID ist ungültig.',
            'uuid.exists'   => 'Die zu löschende Gruppe existiert nicht.'
        ];
    }

    /**
     * @return RedirectResponse
     */
    public function success(): RedirectResponse
    {
        return redirect()->route('admin-groups')->with([
            'success'       => 'Die Gruppe wurde erfolgreich gelöscht.',
            'alert-options' => 'aside'
        ]);
    }

    /**
     * @return RedirectResponse
     */
    public function failed(): RedirectResponse
    {
        return redirect()->route('admin-groups')->with([
            'error' => 'Die Gruppe konnte aufgrund einer technischen Störung nicht gelöscht werden.'
        ]);
    }
}
